package main

import (
  "bufio"
  "fmt"
  "os"
  "math/rand"
  "time"
  "strconv"
)

func creaMarkov(s string) map[string]([]string) {
  r:=make(map[string]([]string))

  for i := 0; i < len(s) - 3; i++ {
    prima := s[i:i+3]    // Tre caratteri a partire dall'i-esimo
    dopo := s[i+3:i+4]   // Carattere che segue il terzetto
    r[prima] = append(r[prima], dopo)
  }
  return r
}

func generaMarkov(m map[string]([]string), n int) string {
  s := "nel"    // Inizio (fisso)
  for len(s) < n { 
    ultimo := s[len(s) - 3:]   // Ultimi tre caratteri generati
    vieneDopoUltimo := m[ultimo]
    n := len(vieneDopoUltimo)
    scelgoACaso := vieneDopoUltimo[rand.Intn(n)]  // Scelgo il prossimo carattere
    s += scelgoACaso
  }
  return s
}

func main() {
  n,_ := strconv.Atoi(os.Args[1])
  rand.Seed(time.Now().UTC().UnixNano())
  scanner := bufio.NewScanner(os.Stdin)
  s := ""
  for scanner.Scan() {
    s += scanner.Text()
    s += " "
  }
  m := creaMarkov(s)
  fmt.Println(generaMarkov(m, n))
}
